#include <config.h>
#include <strchar.h>
#include <exception.h>
#include <thread.h>
#include <socket.h>
#include <cstdio>

#ifdef	__NAMESPACES__
using namespace std;
using namespace ost;
#endif

class ThreadTest: public Thread
{
public:
	ThreadTest();
	void Run();
};

volatile int n = 0;

bool WaitNValue(int value)
{
	for(int i=0;; ++i)
	{
		if (n == value)
			break;
		if (i >= 100)
			return false;
		ccxx_sleep(10);
	}
	return true;
}

bool WaitNNotValue(int value)
{
	for(int i=0;; ++i)
	{
		if (n != value)
			break;
		if (i >= 100)
			return false;
		ccxx_sleep(10);
	}
	return true;
}

ThreadTest::ThreadTest()
{
}

void ThreadTest::Run()
{
	n = 1;

	// wait for main thread
	if (!WaitNValue(2)) return;

	// increment infinitely
	for(;;)
	{
		Yield();
		n = n+1;
	}
}

#undef ERROR
#undef OK
#define ERROR {printf("ko\n"); return 1; }
#define OK {printf("ok\n"); }

int main(int argc, char* argv[])
{
	int i;
	ThreadTest test;

	// test only thread, without sincronization
	printf("***********************************************\n");
	printf("* Testing class Thread without syncronization *\n");
	printf("***********************************************\n");

	printf("Testing thread creation\n\n");
	n = 0;
	test.Start();

	// wait for n == 1
	printf("- thread should set n to 1...");
	if (WaitNValue(1)) OK
	else ERROR;

	// increment number in thread
	printf("\nTesting thread is working\n\n");
	n = 2;
	printf("- thread should change n...");
	if (WaitNNotValue(n)) OK
	else ERROR;
	printf("- thread should change n...");
	if (WaitNNotValue(n)) OK
	else ERROR;
	
	// suspend thread, variable should not change
	printf("\nTesting suspend & resume\n\n");
	test.Suspend();
	i = n;
	printf("- thread should not change n...");
	if (WaitNNotValue(i)) ERROR
	else OK;
	printf("- thread should not change n...");
	if (WaitNNotValue(i)) ERROR
	else OK;

	// resume, variable should change
	test.Resume();
	printf("- thread should change n...");
	if (WaitNNotValue(i)) OK
	else ERROR;
	printf("- thread should change n...");
	if (WaitNNotValue(n)) OK
	else ERROR;

	printf("\nTesting recursive suspend & resume\n\n");
	test.Suspend();
	test.Suspend();
	i = n;
	printf("- thread should not change n...");
	if (WaitNNotValue(i)) ERROR
	else OK;
	printf("- thread should not change n...");
	if (WaitNNotValue(i)) ERROR
	else OK;
	
	test.Resume();
	i = n;
	printf("- thread should not change n...");
	if (WaitNNotValue(i)) ERROR
	else OK;
	printf("- thread should not change n...");
	if (WaitNNotValue(i)) ERROR
	else OK;
	test.Resume();
	printf("- thread should change n...");
	if (WaitNNotValue(i)) OK
	else ERROR;
	printf("- thread should change n...");
	if (WaitNNotValue(n)) OK
	else ERROR;

	printf("\nTesting no suspend on resume\n\n");
	test.Resume();
	printf("- thread should change n...");
	if (WaitNNotValue(i)) OK
	else ERROR;
	printf("- thread should change n...");
	if (WaitNNotValue(n)) OK
	else ERROR;

	return 0;
}
